#ifndef _WINDOW_H_
#define _WINDOW_H_

#include <windows.h>

extern HINSTANCE hInst;

class Window
{
public:
	HWND m_hWnd;
	Window(void);
	virtual ~Window(void);

	virtual INT_PTR RunMsgLoop( void );
	virtual BOOL Create( TCHAR *lpszTitle, int x = CW_USEDEFAULT, int y = 0, int w = CW_USEDEFAULT, int h = 0, int nCmdShow = SW_NORMAL, HWND hParent = NULL );
	HWND GetWndHandle(void) { return m_hWnd; };

protected:
	TCHAR *m_lpszClass;
	HACCEL m_hAccelTable;
	WORD m_idIcon, m_idMenu;
	static INT_PTR CALLBACK _RootWndProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam );
	virtual INT_PTR CALLBACK WndProc( UINT uMsg, WPARAM wParam, LPARAM lParam ) = 0;
	virtual INT_PTR PreTranslateMessage( HWND hWnd, MSG *msg );

};

#endif//_WINDOW_H_
