#ifndef TWAINMAN_H
#define TWAINMAN_H
////////////////////////////////////////////////////////////////////
//	class CTWAINManager	-----ȒPTWAINgăXLi[摜(DIB)
//	肱ނ߂̃NXB
//	Copyright (C) 2001  M.Yamaguchi
//
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//	twain.h́@http://www.twain.org/肩ėĂB
#include ".\twain\twain.h"	



enum{
	TWCC_UNUSABLETWAIN = TWCC_CUSTOMBASE,
	TWCC_DSM_IS_ALREADYOPEN,
	TWCC_DS_IS_ALREADYOPEN,
	TWCC_DS_IS_ALREADYENABLE,

	TWCC_DSM_IS_NOTOPEN,
	TWCC_DS_IS_NOTOPEN,
	TWCC_DS_IS_NOTENABLE,
	TWCC_PROGRAM_ERROR

};


typedef void (*ScanCallBack)(TW_UINT32 twBitmap, void* param1, void* param2);

#define WM_TWAIN_CLOSEDS	(WM_APP+0x1000)
#define WM_TWAIN_COMPLETE	(WM_APP+0x1001)
#define WM_TWAIN_CANCEL		(WM_APP+0x1002)
#define WM_TWAIN_FAILED		(WM_APP+0x1003)

/***************************************************************
	̃NX͂ЂƂĂˁB
	Ƃ΁ACWinApp̃TuNX̃o[ɂƂB
	āAInitInstance()ŏ(initTWAIN())AExitInstance()
	ŏI(ExitTWAIN())B
****************************************************************/
class CTWAINManager /*: public CObject*/	//@CObjecthĂ܂Kv͂ȂłB
{
protected:
	TW_UINT16 CallDSMEntry(TW_IDENTITY* pApp, TW_IDENTITY* pSrc,
							TW_UINT32 DG, TW_UINT16 DAT, TW_UINT16 MSG, TW_MEMREF pData);
protected:
	BOOL m_bOpenDSM;
	BOOL m_bOpenDS;
	BOOL m_bEnableDS;
protected:
	DSMENTRYPROC m_pDSM_Entry;
	HMODULE m_hDSMLib;
	TW_IDENTITY m_AppID;
	TW_IDENTITY m_DSID;
	TW_STATUS m_GlobalStatus;
	ScanCallBack m_pfnCallBack;
	HWND m_hParentWnd;
	void* m_pParam1;
	void* m_pParam2;
protected:
	TW_UINT16 OpenDSM(HWND hWnd);
	TW_UINT16 CloseDSM(HWND hWnd);
	TW_UINT16 SelectDS();
	TW_UINT16 OpenDS();
	TW_UINT16 CloseDS();
	TW_UINT16 EnableDS(HWND hWnd);
	TW_UINT16 DisableDS(HWND hWnd);
	TW_UINT16 NativeXfer();
public:
	CTWAINManager();
	virtual ~CTWAINManager();

	//BCWinApp::InitInstance肩łB
	BOOL InitTWAIN();

	//IBCWinApp::ExitInstance肩łB
	BOOL ExitTWAIN();

	//ScanerĨ_CAO\܂B
	TW_UINT16 SelectScaner(HWND hWnd);

	//ScanerUserInterface\BăXLJnB荞݂̓R[obN֐ŏB
	TW_UINT16 Scan(HWND hWnd, ScanCallBack pfnCallBack, void* param1, void* param2);

	//TWAINgƂTRUEB
	BOOL IsUsableTWAIN();

	//TWAIÑbZ[W[vB
	//Ⴆ΁ACWnd::PreTranslateMessagełłB
	BOOL TranslateMessage(HWND hWnd, MSG* pMsg);
};


#endif
