#ifndef _THREAD_H_
#define _THREAD_H_

#include <windows.h>

class Thread
{
public:
	Thread(void);
	virtual ~Thread(void);

	static DWORD WINAPI _threadStatic( void * );
	virtual DWORD ThreadProc(void);
	virtual void EternalProc(void);

	virtual BOOL Create();
	virtual BOOL Exit( DWORD dwTimeout = INFINITE );
	virtual BOOL Join( DWORD dwTimeout = INFINITE );

protected:
	HANDLE m_hThread;
	BOOL m_bLoop;
};

#endif//_THREAD_H_
