#pragma once

#include <windows.h>
#include <tchar.h>
#include "Window.h"
#include "Thread.h"
#include "TWAINMan.h"

class WindowThread : public Window, public Thread
{
public:
	HGLOBAL hBitmap;
	WindowThread(void);
	~WindowThread(void);
	DWORD ThreadProc(void);
	INT_PTR CALLBACK WndProc( UINT uMsg, WPARAM wParam, LPARAM lParam );
	INT_PTR PreTranslateMessage( HWND hWnd, MSG *msg );
	BOOL Create(void);
	BOOL Exit( DWORD dwTimeout = INFINITE );

protected:
	CTWAINManager twainMan;
	BOOL bSelectScanner;
};
